/**
 * 
 */
package org.etsi.saref.server.resources;


import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;

import org.glassfish.jersey.server.mvc.Template;

import java.awt.Desktop;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.StringWriter;

import com.github.mustachejava.DefaultMustacheFactory;
import com.github.mustachejava.Mustache;
import com.github.mustachejava.MustacheFactory;
import java.util.HashMap;
import java.util.Map;
import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.impl.LiteralImpl;
import org.apache.jena.rdfconnection.RDFConnection;
import org.apache.jena.rdfconnection.RDFConnectionFactory;
import org.apache.jena.sparql.expr.NodeValue;
import org.apache.jena.sparql.expr.nodevalue.NodeValueString;
import org.etsi.saref.server.SAREFServer;

/**
 * @author Omar Qawasmeh
 *
 *
 */

@Path("/search")
public class Search {
    
    private static final String QUERY_COUNT = "PREFIX ex: <http://example.org/>\n" +
        "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>\n" +
        "PREFIX text: <http://jena.apache.org/text#>\n" +
        "SELECT (COUNT(*) AS ?count)\n" +
        "WHERE {\n" +
        "   ( ?s ?score ?literal ?g ) text:query %s .\n" +
        "  OPTIONAL { ?s rdfs:label ?label }\n" +
        "  OPTIONAL { ?s rdfs:comment ?comment }\n" +
        "}";
    private static final String QUERY = "PREFIX ex: <http://example.org/>\n" +
        "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>\n" +
        "PREFIX text: <http://jena.apache.org/text#>\n" +
        "SELECT DISTINCT *\n" +
        "WHERE {\n" +
        "   ( ?s ?score ?literal ?g ) text:query %s .\n" +
        "  OPTIONAL { ?s rdfs:label ?label }\n" +
        "  OPTIONAL { ?s rdfs:comment ?comment }\n" +
        "}\n" +
        "ORDER BY DESC ( ?score )\n" +
        "OFFSET %s\n" +
        "LIMIT %s";

	@GET
	@Produces(MediaType.TEXT_HTML)
	@Template(name = "/search")
	public Map doSearch(@QueryParam("q") String keyword) throws IOException {
            // build Node to avoid injection
            NodeValue nv = new NodeValueString(keyword);
            System.out.println(nv.toString());
            Map<String, String> map = new HashMap<>();
            map.put("results", "");
            return new HashMap<>();
            
//            
//            try (RDFConnection conn = RDFConnectionFactory.connect(SAREFServer.DS)) {
//                
//                ResultSet countRs = conn.query(query)fetch(v.getUri());
//                
//                
//            }
//            
//		SearchKeyWord queryResults = new SearchKeyWord();
//		String results = queryResults.doSearchResultsLabels(keyword);
//                Map<String, String> map = new HashMap<>();
//                map.put("results", results);
//		return map;
	}

}
